import { getObjectMetadata } from "../common/metadata";
import { validateDTO } from "../dto/validator";
import { DtoMetadata } from "../dto/DtoMetadata";
import { AbstractConfiguration } from "./AbstractConfiguration";

export class ConfigurationResolver {
    public static async resolve<T extends AbstractConfiguration>(configurationClass: { new (): T }, configurationObjectResolver: Promise<object>): Promise<T> {
        const configurationObject = validateDTO(((await configurationObjectResolver) as any).default, getObjectMetadata<DtoMetadata>(configurationClass)!);
        const configuration = new configurationClass();
        Object.assign(configuration, configurationObject);
        return configuration;
    }
}
